{ A modal dialog box to select what to read from the parameter file; state
  variables, parameters or both. }
unit ReloadDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Dialogs;

type
  TDlgReload = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    MoDirections: TMemo;
    CbParams: TCheckBox;
    CbState: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure CbParamsClick(Sender: TObject);
    procedure CbStateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DlgReload: TDlgReload;

implementation

uses stypes, fileio, frontend, display;

{$R *.DFM}

// Reload the selected items from the parameter file
procedure TDlgReload.OKBtnClick(Sender: TObject);
var
   i:integer;
   temppar: paramarray; // temporary parmeter array
   tempstat: statearray; // temporary state array
begin
 // Read data from  the parameter file and store in the temporary arrays
  ReadParamFile(paramfilename,modeldef.numparam,
                                            temppar,modeldef.numstate,tempstat);
  if CbParams.Checked and CbState.Checked // Reload params and states
  then
   begin  // Copy values in the temporary array to the global variables
    for i:= 1 to modeldef.numstate do stat[i].value := tempstat[i].value;
    for i:= 1 to modeldef.numparam do par[i].value := temppar[i].value;
    NeedToSavePar := False;
   end
  else
   if CbParams.Checked    // Reload only the parameter values
   then
    for i:= 1 to modeldef.numparam do par[i].value := temppar[i].value
   else
    if CbState.Checked    // Reload only the state variables
    then for i:=1 to modeldef.numstate do stat[i].value := tempstat[i].value
    else;  // don't reload anything

end;

procedure TDlgReload.CbParamsClick(Sender: TObject);
begin
 if cbParams.Checked  = true
 then fmDisplayData.cbParams.Checked := true
 else fmDisplayData.cbParams.Checked := false;
end;

procedure TDlgReload.CbStateClick(Sender: TObject);  
begin
 if cbState.Checked  = true
 then fmDisplayData.cbState.Checked := true
 else fmDisplayData.cbState.Checked := false;
end;

end.
